<?php
/*
WebDevStudio - www.webdevstudio.org
Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

require("../../authentication.php");

//Funcion que indica si la extension de un fichero esta permitida
function check_extension($filename,$extensions) {
	for ($j=0; $j<count($extensions); $j++) {
		//Permitimos los ficheros que son del mismo lenguaje
		$long_extension=strlen($extensions[$j]);
		$extension_file=strtolower(substr($filename, strlen($filename)-$long_extension, $long_extension));
		if ($extension_file==$extensions[$j]) {
			return 1;
		}
		//Permitimos los ficheros de texto
		else if (strtolower(substr($filename, strlen($filename)-4, 4))==".txt" ) {
			return 1;
		}
	}
	return 0;
}

//Comprobamos si se ha permitido subir el fichero
if (isset($_FILES['file']['tmp_name']) &&
	isset($_FILES['file']['size']) &&
	isset($_FILES['file']['name']) ) {
	
	$user=$_SESSION['s_user'];
	$language=$_SESSION['s_language'];
	$name=$_SESSION['s_name'];
	
	$filename= $_FILES['file']['name'];
	$filesize= $_FILES['file']['size'];
	$pathfile="../../users/$user/$name/$filename";

	require("../../config/compile_config.php");
	
	//Compromamos si el fichero que han subido es correcto
	$error=0;
	if ($filename=="") {
		$mensaje_head = "Sorry, there are errors in the form";
    	$mensaje= "All obligatory fields must be completed";
		$error=1;
	}
	else if (!check_extension($filename, $extensions[$language])) {
		$mensaje_head = "Sorry, there are errors in the form";		
		$mensaje="This file cannot be upload<br /><br />Only you can upload \"". $language."\" files or \".txt\" files";
		$error=1;
	}
	else if (strlen($filename) > 12) {
		$mensaje_head = "Sorry, there are errors in the form";		
		$mensaje="Name of file too long.<br /><br />Only 8 characters are admitted";
		$error=1;
	}
	/*
	else if (mime_content_type($file)!="text/plain") {
		$mensaje="This file cannot be upload.<br><br>Only you can upload plain text files";
		$error=1;
	}
	*/
	else if ($filesize > 512000) {
		$mensaje_head = "Sorry, there are errors in the form";		
   		$mensaje = "The size of the file must be inferior to 500 KBytes";
		$error = 1;
	}
	//else if (ereg("[\\/:*?\"<> |\']", $filename) == TRUE) {
	else if (preg_match("/[\\/:*?\"<> |\']/", $filename) == TRUE) {
		$mensaje_head = "Sorry, there are errors in the form";		
		$mensaje = "The name of the file is incorrect.<br /><br />Please, don't use: \, /, :, *, ?, \", <, >,  , |, '";
		$error = 1;
	}
	//else if (file_exists("./users/$user/$name/$file_name")) {
	else if (file_exists($pathfile)) {
		$mensaje_head = "Sorry, there are errors in the form";		
		$mensaje = 'There is another file with this "'.$filename.'" file name';
		$error = 1;
	}
	//El formulario esta correctamente rellenado
	else {
		$file=$_FILES['file']['tmp_name'];
		if (!copy($file, $pathfile)) {
			$mensaje_head = "Sorry, there are errors in the form";			
			$mensaje = "There are problems on updating the file";
			$error = 1;
    	}
	}
}
//No se ha permitido subir el fichero
else {
	$mensaje_head = "Sorry, there are errors with data";
	$mensaje = "The size of the file must be inferior to 500 KBytes";
	$error = 1;
}

//Tratamos los errores
if ($error!=1) {
	$_SESSION['s_file']=$filename;
	header("Location: work_project.php");
}
else {
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <title>WebDevStudio :: An online integrated development environment</title>
    <link href="../../styles/general.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript">	
	/*<![CDATA[*/
		function volver() {
			history.back();
		}
	/*]]>*/
	</script>
</head>
<body>
	<div id="all">
		<?php include("head_project.php") ?>
        <div id="content">
            <div id="content_left">
                <ul class="box_left">
                    <li class="box_title"><img src="../../images/general/box_project.png" alt="Project" />Project</li>
                    <li><img src="../../images/general/box_bullet.png" alt="bullet" /><a onclick="volver()" href="#">Back</a></li>
                </ul>
            </div>
            
            <div id="content_center">
                <div id="result_server">
                	<h2><?php echo $mensaje_head ?></h2>
                    <p><?php echo $mensaje ?></p>
    	            <button onclick="volver()">Back</button>
                </div>
            </div>
        </div>
        <?php include("foot_project.php"); ?>
	</div>
</body>
</html>
<?php } ?>
