/*
WebDevStudio - www.webdevstudio.org
Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/


Actions_Manager = function() {
	
	//Atributos
	//this.fullscreen = new Array();
	var fullscreen = new Array();
	var result_timeout;
	
	
	//Metodos
	this.new_file = function(path) {
		new Ajax.Request('ajax_new.php',
		{
			asynchronous: true,
			contentType: 'application/x-www-form-urlencoded',
			encoding: 'UTF-8',
			method: 'post',
			parameters: {path: path},			
			onCreate: function() {
				actions_manager.print_result("Creating file...");
			},
			onComplete: function(transport) {
				parent.actions_manager.print_result(transport.responseText, true);
				//Si el fichero se va a sobreescribir
				if (actions_manager.is_open(path)) {
					tabs_manager.delete_layer(path);
					//tabs_manager.close_layer(path);
				} 
				else {
					filetree_manager.generate_tree();
				}
				//Abrimos una pestana con ese nuevo fichero
				actions_manager.open_file(path);
				//Cerramos todas las ventanas
				//windows_manager.close_current_window();
				windows_manager.close_all_windows();
				
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		 });
		
	}
	
	this.up_file = function() {
		//window.location = "open_file.php";
		window.location = "../project/open_file.php";
	}
	
	this.open_file = function(path, print_result) {
		if (!this.is_open(path)) {
			editAreaLoader.showWaitingScreen('editor_content');
			
			if (print_result) {
				actions_manager.print_result("Opening file...");
			}

			new Ajax.Request('ajax_open.php',
			{
				method: 'post',
				contentType: 'application/x-www-form-urlencoded',
				asynchronous: true,
				encoding: 'UTF-8',
				parameters: {path: path},
				onCreate: function() {
					//editAreaLoader.showWaitingScreen('editor_content');
					//actions_manager.print_result("Opening file...");
				},
				onComplete: function(transport) {
					//Obtenemos el nombre y la extension del fichero
					var file_name = path.substring(path.lastIndexOf('/')+1, path.length);
					var syntax = path.substring(path.lastIndexOf('.')+1, path.length);
					var new_file = {id: path, text: transport.responseText, syntax: syntax, title: file_name};
					//Cargamos el fichero en el editor
					editAreaLoader.openFile('editor_content', new_file);			
					//Insertamos la nueva pestana
					tabs_manager.insert_layer(path);					
					
					if (print_result) {
						actions_manager.print_result("File opened sucessfully.", true);
					}
					editAreaLoader.hideWaitingScreen('editor_content');
				},
				onFailure: function(){ 
					alert('AJAX error.\nPlease, contact with support.') 
				}
			 });
		}
		else {
			tabs_manager.show_layer(path);
		}
	}
	
	this.is_open = function(path) {
		return tabs_manager.is_open_layer(path);
	}
	
	this.file_exists = function(path) {
		return filetree_manager.file_exists(path);
	}
	
	this.close_file = function(path) {
		tabs_manager.close_layer(path);
	}
	
	//Guarda en el servidor el fichero que indica el path
	this.save_file = function(path, asynchronous) {
		if (this.is_open(path)) {
			var file = editAreaLoader.getFile('editor_content', path)
			var content_txt = file['text'];
			
			new Ajax.Request('ajax_save.php',
			{
				method: 'post',
				contentType: 'application/x-www-form-urlencoded',
				encoding: 'UTF-8',
				asynchronous: asynchronous,
				parameters: {path: path, content: content_txt},
				onCreate: function() {
					actions_manager.print_result("Saving file...");
					tabs_manager.set_file_loading_mode(path,true);
				},
				onComplete: function(transport) {
					tabs_manager.set_file_edited_mode(path, false);
					tabs_manager.set_file_loading_mode(path, false);
					actions_manager.print_result(transport.responseText, true);
				},
				onFailure: function(){ 
					alert('AJAX error.\nPlease, contact with support.') 
				}
			 });
		}
		else {
			this.print_result("Please, open a file.");
		}
	}
	
	//Save actual editing file in server
	this.save_act_file = function() {
		this.save_file(tabs_manager.get_path_act());
	}
	
	//Save all files in server
	this.save_all_files = function(asynchronous) {
		var edited_files = tabs_manager.get_edited_files();
		for (var i=0; i<edited_files.length; i++) {
			//alert(edited_files[i]);
			this.save_file(edited_files[i], asynchronous);
		}
	}
	
	//Check if there are edited files
	this.check_edited_files = function() {
		var edited_files = tabs_manager.get_edited_files();
		if (edited_files.length > 0) {
			var res = window.confirm('There are unsaved files.\nWould you like to save all before exiting?');
			if (res) {
				actions_manager.save_all_files(false);
			}
		}
	}
	
	
	this.down_act_file = function() {
		if (tabs_manager.get_num_layers() > 0) {
			this.down_file(tabs_manager.get_path_act());
		}
		else {
			var result = "Please, open a file.";
			this.print_result(result);
		}
	}
	
	this.down_file = function(path) {
		window.location = path;
	}
	
	this.delete_file = function(path) {
		var r = confirm("Are you sure to delete this file?");
		if (r == true) {
			//Si el fichero esta abierto, lo cerramos
			if (this.is_open(path)) {
				//Quitamos la pestana
				tabs_manager.delete_layer(path);
			}
			
			//Borramos el fichero del servidor
			new Ajax.Request('ajax_delete.php',
			{
				method:'post',
				contentType:'application/x-www-form-urlencoded',
				asynchronous:true,
				encoding: 'UTF-8',
				parameters: {path: path},
				onCreate: function() {
					actions_manager.print_result("Deleting file...");
				},
				onComplete: function(transport) {
					actions_manager.print_result(transport.responseText, true);
					filetree_manager.generate_tree();					
					//Si el fichero se ha borrado desde el explorador de ficheros de una ventana
					if (windows_manager.is_open_window()) {
						path = path.substring(0, path.lastIndexOf("/"));
						windows_manager.update_window_file_explorer('window_file_explorer', path);
					}
				},
				onFailure: function(){ 
					alert('AJAX error.\nPlease, contact with support.') 
				}
			 });			
		} 
	}
	
	
	this.rename_file = function(path, newpath) {
		new Ajax.Request('ajax_rename.php',
		{
			method:'post',
			contentType:'application/x-www-form-urlencoded',
			asynchronous:true,
			encoding: 'UTF-8',
			parameters: {path: path, newpath: newpath},
			onCreate: function() {
				actions_manager.print_result("Renaming file...");
			},
			onComplete: function(transport) {
				//Si el fichero esta abierto, lo renombramos
				if (actions_manager.is_open(path)) {
					//Renombramos la pestana
					tabs_manager.rename_layer(path, newpath);
					//Renombramos tambien en el editor
					editAreaLoader.renameFile('editor_content', path, newpath);
				}
				actions_manager.print_result(transport.responseText, true);
				filetree_manager.generate_tree();
				//Si el fichero se ha renombrado desde el explorador de ficheros de una ventana
				if (windows_manager.is_open_window()) {
					path = path.substring(0, path.lastIndexOf("/"));
					windows_manager.update_window_file_explorer('window_file_explorer', path);
				}		
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		 });

	}
	

	this.new_folder = function(path) {
		new Ajax.Request('ajax_new_folder.php',
		{
			method: 'post',
			contentType: 'application/x-www-form-urlencoded',
			asynchronous: false,
			encoding: 'UTF-8',
			parameters: {path: path},
			onCreate: function() {
				actions_manager.print_result("Creating folder...");
			},
			onComplete: function(transport) {
				actions_manager.print_result(transport.responseText, true);
				filetree_manager.generate_tree();
				//Cerramos las ventanas
				windows_manager.close_all_windows();
				//windows_manager.close_current_window();				
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		 });
		
		
	}
	
	this.delete_folder = function(path) {
		var res = confirm("Are you sure to delete this folder and all its contents?");
		
		if (res == true) {
			//Comprobamos los ficheros que se están editando
			//Obtenemos todos los ficheros que pertenecen al path que se quiere eliminar
			var all_files_folder = filetree_manager.get_all_files_folder(path);
			//Cerramos los ficheros que se están editando
			for (var i=0; i<all_files_folder.length; i++) {
				if (this.is_open(all_files_folder[i]['path'])) {
					tabs_manager.delete_layer(all_files_folder[i]['path']);
				}
			}
		
			new Ajax.Request('ajax_delete_folder.php',
			{
				method: 'post',
				contentType: 'application/x-www-form-urlencoded',
				encoding: 'UTF-8',
				asynchronous:false,
				parameters: {path: path},
				onCreate: function() {
					actions_manager.print_result("Deleting folder...");
				},
				onComplete: function(transport) {
					actions_manager.print_result(transport.responseText, true);
					filetree_manager.generate_tree();
					//Si la carpeta se ha borrado desde el explorador de ficheros de una ventana
					if (windows_manager.is_open_window()) {
						//path = path.substring(0, path.lastIndexOf("/"));
						windows_manager.update_window_file_explorer('window_file_explorer', path);
					}				},
				onFailure: function(){ 
					alert('AJAX error.\nPlease, contact with support.') 
				}
			 });			
			}
	}
	
	this.rename_folder = function(path, newpath) {
		new Ajax.Request('ajax_rename.php',
		{
			method:'post',
			contentType:'application/x-www-form-urlencoded',
			asynchronous:false,
			parameters: {path: path, newpath: newpath},
			onCreate: function() {
				actions_manager.print_result("Renaming folder...");
			},
			onComplete: function(transport) {
				//Cambiamos las rutas de los ficheros que estan abiertos
				var opened_files = tabs_manager.get_opened_files();
				for (var i=0; i<opened_files.length; i++) {
					//Si el fichero abierto contiene esa ruta, lo renombramos
					var file_path = opened_files[i];
					if (file_path.search(path) >= 0) {
						//Obtenemos la nueva ruta del fichero						
						var new_file_path = file_path.replace(path, newpath);
						//Renombramos la pestana
						tabs_manager.rename_layer(file_path, new_file_path);
						//Renombramos tambien en el editor
						editAreaLoader.renameFile('editor_content', file_path, new_file_path);	
					}
				}
				
				actions_manager.print_result(transport.responseText,true);
				filetree_manager.generate_tree();
				//Si el fichero se ha renombrado desde el explorador de ficheros de una ventana
				if (windows_manager.is_open_window()) {
					path = path.substring(0, path.lastIndexOf("/"));
					windows_manager.update_window_file_explorer('window_file_explorer', path);
				}		
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		 });
		
	}
	
	
	//Funciones para la compilacion y generacion
	this.compile = function() {
		if (tabs_manager.get_num_layers() > 0) {
			var content_txt = editAreaLoader.getValue('editor_content');
			var path_act = tabs_manager.get_path_act();
			
			//Salvamos el fichero actual antes de compilarlo
			actions_manager.save_file(path_act, false);

			new Ajax.Request('ajax_compile.php',
			{
				method:'post',
				contentType:'application/x-www-form-urlencoded',
				asynchronous:true,
				//parameters: {path: PATH_PROJECT, file: path_act, content: content_txt},
				parameters: {path: PATH_PROJECT, file: path_act},
				onCreate: function() {
					actions_manager.print_result("Compiling file...");					
				},
				onComplete: function(transport) {
					actions_manager.print_result(transport.responseText, false);
				},
				onFailure: function(){ 
					alert('AJAX error.\nPlease, contact with support.') 
				}
			 });			
		}
		else {
			this.print_result("Please, open a file.");
		}
	}
	
	this.build = function() {
		/*
		this.print_result("Building project...");
		var path_act = tabs_manager.get_path_act();		
		if (tabs_manager.get_num_layers() > 0) {
			//var content_txt = editAreaLoader.getValue('editor_content');
			var parameters = {path: PATH_PROJECT, file: path_act, content: content_txt}
		}
		else {
			var parameters = {path: PATH_PROJECT};
		}
		*/
		
		//Guardamos todos los ficheros
		actions_manager.save_all_files(false);
		
		new Ajax.Request('ajax_build.php',
		{
			method: 'post',
			contentType: 'application/x-www-form-urlencoded',
			asynchronous: true,
			parameters: {path: PATH_PROJECT},
			onCreate: function() {
				actions_manager.print_result("Building project...");					
			},
			onComplete: function(transport) {
				actions_manager.print_result(transport.responseText, false);
				filetree_manager.generate_tree();
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		 });		
	}
	
	//Funciones de la barra de herramientas
	this.indent = function() {
		//alert("indentar");
		//document.getElementById('editor').contentWindow.document.execCommand("indent", false, null);
	}
	
	this.outdent = function() {
		//alert("indentar");
		//document.getElementById('editor').contentWindow.document.execCommand("outdent", false, null);
	}
	
	this.copy = function() {
		
		var txt = editAreaLoader.getSelectedText('editor_content');
		
		if(window.clipboardData) {
			window.clipboardData.clearData();
			window.clipboardData.setData("Text", txt);
			return true;
		} 
		else if(navigator.userAgent.indexOf("Opera") != -1) {
			window.location = txt;
		} 
		else if (window.netscape) {
			try {
				netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
			}
			catch (e) {
				alert("Unprivileged scripts cannot access Cut/Copy/Paste programatically for security reasons.\n"+
					  "You need set 'signed.applets.codebase_principal_support=true' at about:config'");
				return false;
			}
			
			var clip = Components.classes['@mozilla.org/widget/clipboard;1'].createInstance(Components.interfaces.nsIClipboard);
			if (!clip)
				return;
			var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
			if (!trans)
				return;
				
			trans.addDataFlavor('text/unicode');
			var str = new Object();
			var len = new Object();
			var str = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
			var copytext = txt;
			str.data = copytext;
			trans.setTransferData("text/unicode",str,copytext.length*2);
			var clipid = Components.interfaces.nsIClipboard;
			if (!clip)
				return false;
			clip.setData(trans,null,clipid.kGlobalClipboard);
			return true;
		}
	}
	
	this.paste = function() {
		
		/*
		//Paste IE	
		var txt = window.clipboardData.getData('Text');
		editAreaLoader.setSelectedText('editor_content', txt);
		*/
		var txt = '';
		
		if(window.clipboardData) {
			txt = window.clipboardData.getData('Text');
			//content.document.execCommand("paste", false, null);
			return true;
		} 
		else if(navigator.userAgent.indexOf("Opera") != -1) {
			//window.location = txt;
			txt = window.location;
		} 
		else if (window.netscape) {
			try {
				netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
			}
			catch (e) {
				alert("Unprivileged scripts cannot access Cut/Copy/Paste programatically for security reasons.\n"+
					  "You need set 'signed.applets.codebase_principal_support=true' at about:config'");
				return false;
			}
		
			var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
			if (!clip) 
				return false;
			var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
			if (!trans) 
				return false;
			trans.addDataFlavor("text/unicode");
			clip.getData(trans, clip.kGlobalClipboard);
			var str = new Object();
			var strLength = new Object();
			trans.getTransferData("text/unicode", str, strLength);	
			if (str)
				str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
			if (str) 
				pastetext = str.data.substring(0, strLength.value / 2);
				
			txt = pastetext;
			return true;
		}
		
		if (txt != '') {
			editAreaLoader.setSelectedText('editor_content', txt);
		}
	}
	
	this.cut = function() {
		if (this.copy()) {
			editAreaLoader.setSelectedText('editor_content', '');
		}
	}
	
	this.undo = function() {

		editAreaLoader.undo('editor_content');
		/*
		var content = document.getElementById('iframe_content_'+id_act);
		
		//if (document.getElementById('myfile_cp')) {
		if (content) {
			try {
				//document.execCommand("undo", false, null);
				content.contentWindow.document.execCommand("undo", false, null);
				//document.getElementById('myfile').contentWindow.document.execCommand("undo", false, null);
			}
			catch (e) {
				alert("This function is not supported on your web browser.");
			}
		}
		*/
		
	}
	
	this.redo = function() {
		editAreaLoader.redo('editor_content');		
		/*
		if (document.getElementById('editor')) {
			editor.do_Redo();
		}
		*/
		/*
		var content = document.getElementById('iframe_content_'+id_act);
		
		//if (document.getElementById('myfile_cp')) {
		if (content) {
			try {
				//document.execCommand("redo", false, null);
				content.contentWindow.document.execCommand("redo", false, null);
			}
			catch (e) {
				alert("This function is not supported on your web browser.");
			}
		}
		*/
	}
	
	
	this.print_code = function() {
		if (tabs_manager.get_num_layers() > 0) {
			//parent['frame_editor_content'].focus();
			//parent['frame_editor_content'].print();
			window.frames['frame_editor_content'].focus();
			window.frames['frame_editor_content'].print();

		}
		else {
			$('results').value = "Please, open a file";
		}
	}
	
	this.backup = function() {
		//window.location = "create_backup.php";
		window.location = "../project/create_backup.php";
	}
	
	
	this.help = function() {
		window.location = "../help/toolbar_help.php";
	}
	
	
	this.show_search = function() {
		if (tabs_manager.get_num_layers() > 0) {
			//editAreaLoader.execCommand('editor_content','show_search()');
			windows_manager.show_search_window();
		}
		else {
			this.print_result("Please, open a file.");
		}
	}
	
	this.go_to_line = function() {
		if (tabs_manager.get_num_layers() > 0) {
			//editAreaLoader.execCommand('editor_content','go_to_line()');
			windows_manager.show_goto_line_window();
		}
		else {
			this.print_result("Please, open a file.");
		}		
	}
	

	this.toggle_full_screen = function(to){
		//Comprobamos el estado
		if(typeof(to)=="undefined") {
			//to= !this.fullscreen['isFull'];
			to = !fullscreen['isFull'];
		}
		//var old = this.fullscreen['isFull'];
		//this.fullscreen['isFull'] = to;
		var old = fullscreen['isFull'];
		fullscreen['isFull'] = to;
		
		//var icon= $("fullscreen");
		
		if(to && to!=old) {
			//Obtenemos los antiguos valores de los elementos que vamos a modificar
			//this.fullscreen['center_zone_width_old'] = $("center_zone").getWidth();
			//this.fullscreen['editor_zone_content_height_old'] = $("editor_zone_content").getHeight();
			fullscreen['center_zone_width_old'] = $("center_zone").getWidth();
			fullscreen['editor_zone_content_height_old'] = $("editor_zone_content").getHeight();

			//Ocultamos las capas que no nos interesan
			$('head').setStyle({display: 'none'});
			$('foot').setStyle({display: 'none'});
			
			//Calculamos las nuevas medidas
			var content_witdh = $("content").getWidth();
			var right_zone_width = $("right_zone").getWidth();
			var offset_center_zone = (content_witdh - right_zone_width) - 50;		
			var content_height = $("content").getHeight();
			var buttons_bar_height = $("buttons_bar").getHeight();
			var result_zone_content_height = $("result_zone_content").getHeight();
			var offset_editor_zone_content = (content_height - buttons_bar_height - result_zone_content_height ) - 20;
			//Aplicamos los cambios					
			$('center_zone').setStyle({width: offset_center_zone+"px"});
			$('editor_zone_content').setStyle({height: offset_editor_zone_content+"px"});
		}
		else if(to != old) {
			//Recuperamos los tamanos iniciales
			//$('center_zone').setStyle({width: this.fullscreen['center_zone_width_old']+"px"});
			//$('editor_zone_content').setStyle({height: this.fullscreen['editor_zone_content_height_old']+"px"});
			$('center_zone').setStyle({width: fullscreen['center_zone_width_old']+"px"});
			$('editor_zone_content').setStyle({height: fullscreen['editor_zone_content_height_old']+"px"});
			
			//Mostramos las capas ocultas
			$('head').setStyle({display: 'block'});
			$('foot').setStyle({display: 'block'});
		}
	}

	
	
	//Funciones auxiliares
	//Muestra un mensaje en el area de resultados.
	//Si 'disappear' es cierto, al cabo de un tiempo dasaparece el mensaje
	this.print_result = function(str, disappear) {
		//this.show_result(0);
		tabs_manager.show_result(0);
		
		//Preparamos el string para IE
		//var ua = navigator.userAgent;
		//if(ua.match('MSIE')) {
		if (gui_manager.nav['isIE']) {
			//str = str.replace(/\n/g, "\r\n");
			str = str.replace(/\n/g, "<br />");
		}
		$("results").innerHTML = '<pre>'+str+'</pre>';
		//document.getElementById("result_container0").innerHTML = '<pre>'+str+' </pre>';

		this.print_log(str);
		
		$("results").style.backgroundColor = '#eaf1d0';
		new Effect.Highlight($("results"), {startcolor: '#eaf1d0', endcolor: '#FFFFFF', restorecolor: '#FFFFFF' });
		
		clearTimeout(result_timeout);
		if (disappear) {
			result_timeout = setTimeout( function() {$("results").innerHTML = '<pre></pre>';}, 5000); 
		}
	}
	
	
	this.print_log = function(str) {
		var date = new Date();
		var current_time = date.toLocaleTimeString();

		//Insertamos una nueva linea por cada accion
		if (gui_manager.nav["isIE"]) {
			//str += "\r\n";
			str += "<br />";
		}
		else {
			str += "\n";
		}
		//$("logs").innerHTML += current_time+' : '+str+"<br />";
		$("logs").firstChild.innerHTML += current_time+' : '+str;
	}
	
	this.clear_log = function() {
		$("logs").firstChild.innerHTML = '';
	}

	

	
	/*	
	this.show_result = function(num) {

		//Obtenemos las pestanas
		var tabbar = $('result_tabbar');
		var tab_nodes = tabbar.childNodes;
		
		//Ponemos todas las pestanas apagadas
		for (var i=0; i<tab_nodes.length; i++) {
			if (tab_nodes[i].nodeType==1) {
				tab_nodes[i].style.backgroundColor = "#EEEEEE";
			}
		}
		
		//Obtenemos los contenedores
		var container = $('result_container_main');
		var container_nodes = container.childNodes;
	
		//Ponemos todos los contenedores ocultos
		for (var i=0; i<container_nodes.length; i++) {
			if (container_nodes[i].nodeType==1) {
				container_nodes[i].style.display = "none";
			}
		}
		
		//Encendemos la pestana
		var tab = $('result_tab'+num);
		tab.style.backgroundColor = "#DEDEDE";
		
		var content = $('result_container'+num);
		content.style.display = "block";
	}
	*/
	

}

var actions_manager = new Actions_Manager();
