/*
WebDevStudio - www.webdevstudio.org
Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/


cmd = {};

cmd.client_commands = {"":0,"clear":1, "help":2, "open":3, "close":4, "mkdir":5};
cmd.mixed_commands = {"rm":0,"make":1, "gcc":2, "gpp":3, "run":4, "man":5};

cmd.history = new Array();
//cmd.history[0] = "";
cmd.history.unshift("");
cmd.history_index = 0;

cmd.exec = function(str) {
	//Mostramos la imagen de carga
	document.getElementById("result_loading").style.display = "block";
	
	if(str) {
		document.getElementById("cmd_input").value = str;
	}
	var comStr = document.getElementById("cmd_input").value;
	var m = comStr.match(/\w+/);
	var com = (m && m.length) ? m[0] : "";
	cmd.echo(document.getElementById("cmd_prompt").innerHTML+comStr);
		
	//Acciones para el historial
	//cmd.history.push(comStr);
	cmd.history.shift();
	cmd.history.unshift(comStr);
	cmd.history.unshift("");
	cmd.history_index = 0;

	//Seleccionamos el tipo de mandato
	if(com in cmd.client_commands){
		//cmd.run(com, comStr);
		cmd.run(comStr);
	} 
	else if (com in cmd.mixed_commands) {
		//cmd.send(com, comStr);
		cmd.send(comStr);
		filetree_manager.generate_tree();
	}
	else {
		//cmd.send(com, comStr);
		cmd.send(comStr);
	}
	
	document.getElementById("cmd_area").scrollTop = 1000000;
	document.getElementById("cmd_input").value = "";
	
	
}

//Envio del mandato directamente al servidor
//cmd.send = function(com, comStr) {
cmd.send = function(comStr) {
	/*
	var ajax_obj = new Ajax_Editor();
	var url = "cmd/cmd.php?";
	var parameters = "com="+com+"&comStr="+comStr;
	var response = ajax_obj.request_synchronous_text(url, parameters);
	cmd.echo(response);
	*/
	
	new Ajax.Request('cmd/cmd.php',
	{
		method:'post',
		contentType:'application/x-www-form-urlencoded',
		asynchronous: 'false',
		//parameters: {com: com, comStr: comStr},
		parameters: {comStr: comStr},
		onComplete: function(transport) {
			cmd.echo(transport.responseText);
			//Ocultamos la imagen de carga
			document.getElementById("result_loading").style.display = "none";
		},
		onFailure: function(){ 
			alert('AJAX error.\nPlease, contact with support.') 
		}
	 });
	
}

//El mandato se ejecura solamente en el cliente
cmd.run = function(comStr) {
	//var cmd_text = document.getElementById("cmd_text");
	
	//Dividimos la cadena del mandato en mandato y argumentos
	var comArray = comStr.split(" ");
	com = comArray[0];
	
	var response;
	switch(com) {
		case "clear":
			document.getElementById("cmd_text").innerHTML = "<PRE>WebDevStudio Command Line</PRE>";
			cmd.show();
			break;
			
		case "open":
			if (comArray.length > 2) {
				response = ""+
					"open: too many arguments\n"+
					"Try 'open --help' for more information.";					
				cmd.echo(response);
				break;
			}
			else if (comArray.length == 1) {
				response = ""+
					"open: too few arguments\n"+
					"Try 'open --help' for more information.";
				cmd.echo(response);
				break;
			}
			else if (comArray[1] == "--help") {
				response = ""+
					"Usage: open FILE\n"+
					"Open the FILE in the text editor.";
				cmd.echo(response);
				break;
			}
			else {	
				var file = comArray[1];
				if (file && !actions_manager.file_exists(PATH_PROJECT+'/'+file)) {
					response = ""+
						"open: cannot open '"+file+"': No such file";
					cmd.echo(response);
				}
				else {
					actions_manager.open_file(PATH_PROJECT+'/'+file, false);
				}
				break;
			}
			
		case "close":
			if (comArray.length > 2) {
				response = ""+
					"close: too many arguments\n"+
					"Try 'close --help' for more information.";					
				cmd.echo(response);
				break;
			}
			else if (comArray.length == 1) {
				response = ""+
					"close: too few arguments\n"+
					"Try 'close --help' for more information.";
				cmd.echo(response);
				break;
			}
			else if (comArray[1] == "--help") {
				response = ""+
					"Usage: close FILE\n"+
					"close the opened FILE in the text editor.";
				cmd.echo(response);
				break;
			}
			else {	
				var file = comArray[1];
				if (file && !actions_manager.is_open(PATH_PROJECT+'/'+file)) {
					response = ""+
						"close: cannot close '"+file+"': No such file";
					cmd.echo(response);
				}
				else {
					//tabs_manager.close_layer(PATH_PROJECT+'/'+file);
					actions_manager.close_file(PATH_PROJECT+'/'+file);
				}
				break;
			}		
			
		case "mkdir":
			break;
			
		case "help":
			//alert("entra");
			 response = ""+
				"Available commands:\n"+
				"  clear - clear command line screen\n"+
				"  dir   - list directory contents\n"+
			    "  ls    - list directory contents\n"+
				"  rm    - remove files or directories\n"+
				"  open  - open file\n" +
				"  close - close file\n" +
				"  gcc   - GNU project C compiler\n"+
				"  gpp   - GNU project C++ compiler\n"+
				"  make  - GNU make utility to maintain groups of programs\n"+
				"  run   - execute program\n"+
				"  man   - manual";
			//alert(cmd_text);
			cmd.echo(response);
			break;
			
		default:
			response = com+": Command not found";
			cmd.echo(response);
			break;
	}
	
	//Ocultamos la imagen de carga
	document.getElementById("result_loading").style.display = "none";
	
	
}


cmd.hide = function() {
	//document.getElementById("cmd_input").value = "";
	document.getElementById("cmd_prompt").style.visibility = "hidden";
	document.getElementById("cmd_input").blur();
}

cmd.show = function(txt) {
	document.getElementById("cmd_prompt").style.visibility = "visible";
	cmd.focus();
	//document.getElementById("cmd_prompt").innerHTML = (txt || cmd.currentDir)+">"
}

cmd.focus = function() {
	try {
		if(document.getElementById("cmd_prompt").style.visibility != 'hidden') {
			document.getElementById("cmd_input").focus();
		}
	} 
	catch(e) {
	}
}

cmd.echo = function(str) {
	/*
	var ua = navigator.userAgent;
	if(ua.match('MSIE')) {
	*/
	if (gui_manager.nav['isIE']) {
		//Preparamos el string para IE
		str = str.replace(/\n/g, "\n\r");
	}

	var node = document.createElement("pre");
	node.appendChild(document.createTextNode(str));
	document.getElementById("cmd_text").appendChild(node);
	cmd.show();
}

cmd.key = function(evt) {
	var key = evt.keyCode;
	if(key == 38) {
		if (++cmd.history_index >= cmd.history.length-1) {
			cmd.history_index = cmd.history.length-1;
		}
		document.getElementById("cmd_input").value = cmd.history[cmd.history_index];
	}
	else if (key == 40) {
		if (--cmd.history_index < 0) {
			cmd.history_index = 0;
		}
		document.getElementById("cmd_input").value = cmd.history[cmd.history_index];
	}
	else {
		cmd.resize();
	}
}

cmd.resize = function() {
	var input = document.getElementById("cmd_input");
	input.size = input.value.length + 3;
}



