/*
WebDevStudio - www.webdevstudio.org
Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/


var Filetree_Manager = function() {
	//Atributos	
	var xml_filetree;			//XML con la estructura de ficheros del proyecto
	var xml_fileextensions; 	//XML con las extensiones de los ficheros admitidos del proyecto
	var settings;				//Configuracion
	
	//Metodos
	this.init = function(init_settings) {
		//Comprobamos que se han completado los datos de configuracion
		settings = init_settings;
		if(!settings["id"] || !settings["path"] || !settings["project"]) {
			alert("Filetree configuration error");
			return;
		}
		else {
			this.generate_tree();
			//xml_fileextensions = get_ajax_xmlextensions();
			get_ajax_xmlextensions();
		}
	}
		
	this.generate_tree = function() {
		var path = settings['path'];
		var id = settings['id'];
		var project = settings['project'];

		//Indicamos que se esta cargando el arbol
		$(id).innerHTML = '<img src="../../images/general/animated_loading_green.gif" align="top" /> Loading...';		
		
		//get_ajax_xmlfiletree(path, true);
		
		new Ajax.Request('ajax_filetree.php',
		{
			method: 'post',
			contentType: 'application/x-www-form-urlencoded',
			asynchronous: true,
			encoding: 'UTF-8',
			parameters: {path: path, all_filetree: true},
			onComplete: function(transport) {
				xml_filetree = transport.responseXML.documentElement;
				filetree_manager.display_filetree(id, project, xml_filetree);				
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		 });
		
		
	}


	this.display_filetree = function(id, project, xml) {
		//Creamos el arbol
		d = new dTree('d');
		d.add(0, -1, project, 'onmouseout="dropmenu.delayhidemenu()" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenuroot\'); return false;"', 'onclick="dropmenu.dropdownmenu(event, this, \'dropmenuroot\')" onmouseout="dropmenu.delayhidemenu()" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenuroot\'); return false;"');
		display_filetree_aux(xml, 0, 0); 
		$(id).innerHTML = d;
	}
	
	display_filetree_aux = function(xml, id, pid) {
		var nodes = xml.childNodes;
			
		for(var i=0; i<nodes.length; i++) {
			id++;
			var type = nodes[i].getAttribute('type');
			var name = nodes[i].getAttribute('name');
			var path = nodes[i].getAttribute('path');
			var image = nodes[i].getAttribute('image');
			//alert('i:'+i+',id:'+id+',pid:'+pid+',type:'+type+',name:'+name+',path:'+path+',image:'+image);
			if (type == "dir") {
				//No puede llevar onclick
				//Node(id, pid, name, functionText, functionIcon, title, icon, iconOpen, open);
				d.add(id, pid, unescape(name), 'onmouseout="dropmenu.delayhidemenu()" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenufolder\', \''+path+'\'); return false;"',                 'onclick="dropmenu.dropdownmenu(event, this, \'dropmenufolder\', \''+path+'\')" onmouseout="dropmenu.delayhidemenu()" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenufolder\', \''+path+'\'); return false;"', '', image);
				id = display_filetree_aux(nodes[i], id, id);
			}
			else {
				d.add(id, pid, unescape(name), 'onclick="actions_manager.open_file(\''+path+'\', true)" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenufile\', \''+path+'\'); return false;"', 'onclick="dropmenu.dropdownmenu(event, this, \'dropmenufile\', \''+path+'\')" onmouseout="dropmenu.delayhidemenu()" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenufile\', \''+path+'\'); return false;"',     '', image, image);
			}
		}	
		return id;
	}
	
	//Obtiene del servidor el xml de la estructura de ficheros dado un path
	//this.get_xmlfiletree = function(path) {
	get_ajax_xmlfiletree = function(path, all_filetree, asynchronous) {
		new Ajax.Request('ajax_filetree.php',
		{
			method: 'post',
			contentType: 'application/x-www-form-urlencoded',
			asynchronous: asynchronous,
			encoding: 'UTF-8',
			parameters: {path: path, all_filetree: all_filetree},
			onComplete: function(transport) {
				xml_filetree = transport.responseXML.documentElement;				
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		});
	}
	

	//Obtiene del servidor el xml con las extensiones permitidas para este proyecto
	//this.get_xmlextensions = function() {
	get_ajax_xmlextensions = function() {
		
		new Ajax.Request('ajax_extensions.php',
		{
			method: 'post',
			contentType: 'application/x-www-form-urlencoded',
			asynchronous: false,
			encoding: 'UTF-8',
			parameters: {language: encodeURIComponent(LANGUAGE)},
			onComplete: function(transport) {
				//xml_fileextensions = transport.responseXML.firstChild;
				xml_fileextensions = transport.responseXML.documentElement;
				//return xml_fileextensions;
			},
			onFailure: function(){ 
				alert('AJAX error.\nPlease, contact with support.') 
			}
		 });
	}

	this.get_file_extensions = function() {
		var nodes = xml_fileextensions.childNodes;
		var fileextensions = new Array();
		for(var i=0; i<nodes.length; i++) {
			var name = nodes[i].getAttribute('name');
			var description = nodes[i].getAttribute('description');
			
			fileextensions[i] = new Array();
			fileextensions[i]['name'] = name;
			fileextensions[i]['description'] = description;
		}
		return fileextensions;
	}
	
	//Obtiene el array con el contenido de una carpeta
	this.get_content_folder = function(path, all_filetree) {
				
		//Siempre actualizamos
		get_ajax_xmlfiletree(path, all_filetree, false);

		//Nos quedamos solo con las carpetas
		var folders = xml_filetree.getElementsByTagName('folder');

		//Inicializamos la carpeta buscada con todo el xml
		var folder = xml_filetree;
		//Buscamos la carpeta
		for (var i=0; i<folders.length; i++) {
			if (unescape(folders[i].getAttribute('path')) == path) {
				folder = folders[i];
			}
		}
		
		//Generamos el array con los datos
		var content_folder = new Array();
		var nodes = folder.childNodes;
		for(var i=0; i<nodes.length; i++) {
			content_folder[i] = new Array();
			content_folder[i]['type'] = nodes[i].getAttribute('type');
			content_folder[i]['name'] = unescape(nodes[i].getAttribute('name'));
			content_folder[i]['path'] = unescape(nodes[i].getAttribute('path'));
			content_folder[i]['image'] = unescape(nodes[i].getAttribute('image'));			
		}
		return content_folder;
	}
	
	/*
	//Obtiene el array con los ficheros que estan en ese path
	this.get_files_folder = function(path) {
		//Obtenemos el contenido de esa carpeta
		var content_folder = this.get_content_folder(path);
		//Nos quedamos solo con los ficheros
		var files = new Array();
		var j=0;
		for(var i=0; i<content_folder.length; i++) {
			if (content_folder[i]['type'] == 'file') {
				files[j] = new Array();
				files[j] = content_folder[i];
				j++;				
			}
		}
		return files;
	}
	*/

	//Indica si el fichero ya existe en la carpeta donde se va a crear
	this.file_exists = function(newfile_path) {
		var path = newfile_path.substring(0, newfile_path.lastIndexOf("/"));
		//Obtenemos los ficheros que hay dentro de la carpeta
		var content_folder = this.get_content_folder(path, false, false);
		//Comprobamos si el fichero esta en esa carpeta
		for (var i=0; i<content_folder.length; i++) {	
			if (content_folder[i]['path'] == newfile_path) {
				return true;
			}
		}	
		return false;
	}
	
	//Devuelve en un array todo el arbol de ficheros que cuelga a partir de un path
	this.get_all_files_folder = function(path) {
		var content_folder = new Array();
		var content_folder_temp = this.get_content_folder(path, true);

		for (var i=0; i<content_folder_temp.length; i++) {
			if (content_folder_temp[i]['type'] != 'file') {
				var content_folder_part = new Array();
				content_folder_part = this.get_all_files_folder(content_folder_temp[i]['path']);
				content_folder = content_folder.concat(content_folder_part);
			}
			else {
				content_folder.push(content_folder_temp[i]);
			}
		}
		return content_folder;	
	}	
}


var filetree_manager = new Filetree_Manager();