/*
WebDevStudio - www.webdevstudio.org
Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

Tabs_Manager = function() {

	var num_layers = 0;		//Numero de ficheros abiertos actualmente
	var position = 0;		//Posicion de las pestanas en la barra de pestanas		
	
	//var id_layer = "";
	var id_act = "";
	var id_ant = "";

	this.insert_layer = function(path) {
		//var id_layer = path;
		num_layers++;
		
		var file = path.substring(path.lastIndexOf('/')+1, path.length);
	
		//Introducimos la pestana nueva
		//var tabHTML = '<li id="tab_'+id_layer+'" class="tab" onclick="tabs_manager.show_layer(\''+path+'\')"><img id="tab_img_loading_'+id_layer+'" src="../../images/general/animated_loading_green.gif" style="float:left;margin-right:5px;display:none;" /><div id="tab_name_'+id_layer+'" style="float:left">'+unescape(file)+'</div><div id="tab_status_'+id_layer+'" style="display:none;float:left;margin-left:3px;">*</div><img src="../../images/editor/tabs/close_tab.png" onclick="tabs_manager.close_layer(\''+path+'\')" style="margin-left:5px;float:left;cursor:pointer;" /></li>';		
		//var tabHTML = '<li id="tab_'+path+'" class="tab" onclick="tabs_manager.show_layer(\''+path+'\')" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenutab\', \''+path+'\'); return false;"><img id="tab_img_loading_'+path+'" class="tab_loading_img" alt="loading" src="../../images/general/animated_loading_green.gif" /><div id="tab_name_'+path+'" class="tab_name">'+unescape(file)+'</div><div id="tab_status_'+path+'" class="tab_status">*</div><img id="tab_img_close_'+path+'" src="../../images/editor/tabs/close_tab.png" alt="close" class="tab_close_img" onclick="tabs_manager.close_layer(\''+path+'\')" /></li>';				

		//var tabHTML = '<li id="tab_'+path+'" class="tab" onclick="tabs_manager.show_layer(this.id.substr(4))" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenutab\', this.id.substr(4)); return false;"><img id="tab_img_loading_'+path+'" class="tab_loading_img" alt="loading" src="../../images/general/animated_loading_green.gif" /><div id="tab_name_'+path+'" class="tab_name">'+unescape(file)+'</div><div id="tab_status_'+path+'" class="tab_status">*</div><img id="tab_img_close_'+path+'" src="../../images/editor/tabs/close_tab.png" alt="close" class="tab_close_img" onclick="tabs_manager.close_layer(this.id.substr(14))" /></li>';				
		var tabHTML = '<li id="tab_'+path+'" class="tab" onclick="tabs_manager.show_layer(this.id.substr(4))" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenutab\', this.id.substr(4)); return false;"><img id="tab_img_loading_'+path+'" class="tab_loading_img" alt="loading" src="../../images/general/animated_loading_green.gif" /><div id="tab_name_'+path+'" class="tab_name">'+unescape(file)+'</div><div id="tab_status_'+path+'" class="tab_status">*</div><img id="tab_img_close_'+path+'" src="../../images/editor/tabs/close_tab.png" alt="close" class="tab_close_img" onclick="tabs_manager.close_layer(this.parentNode.id.substr(4));" /></li>';

		var tabs = $('tabs');
		tabs.innerHTML = tabHTML + tabs.innerHTML;
		
		//Mostramos el contenido recien creado
		this.show_layer(path);
		
		//Preparamos los botones de desplazamiento de las pestanas
		if (num_layers <= 1) {
			this.disabled_btn('tab_right');
			this.disabled_btn('tab_left');
		}
		else if (num_layers > 1) {
			this.enabled_btn('tab_left');
		}
		
		if (position <= 0) {
			this.disabled_btn('tab_right');
		}
		
		//Hacemos que las pestanas puedan moverse
		Sortable.create("tabs",
     		{dropOnEmpty:true,
			 containment:["tabs"],
			 constraint:"horizontal",
			 overlap:"horizontal",
			 zindex:1});
	}		
	
	
	this.close_layer = function(path) {
		//alert('close_layer('+path+')');
		//Comprobamos si la pestana ha sido modificada y queremos guardarla
		if (this.is_edited_file(path)) {			
			var name = $('tab_name_'+path).firstChild.nodeValue;
			var res = window.confirm('Save changes to document "'+name+'" before closing?');
			if (res) {
				actions_manager.save_file(path);
			}
		}
		this.delete_layer(path);
	}
	
	
	this.delete_layer = function(path) {
		//alert("delete_layer("+path+")");
		num_layers--;
	
		var tab = $('tab_'+path);
		
		//Si la pestana que eliminamos es la activada, buscamos la siguiente
		if ((num_layers > 0) && (id_act == path)) {
			var tab_cont = tab.previousSibling;
			//Si no hay un nodo anterior, vamos al siguiente
			if (tab_cont == null) {
				tab_cont = tab.nextSibling;
			}
			
			//Obtenemos el path de ese nodo
			var id = tab_cont.getAttribute('id');
			var path_cont = id.substring(4, id.length);
			this.show_layer(path_cont);
		}
		
		//Eliminamos la pastana
		tab.parentNode.removeChild(tab);
		//Eliminamos el contenido
		editAreaLoader.closeFile('editor_content', path);
		
		//Si borramos la ultima pestana visible
		if (num_layers == position) {
			this.move_tab_right();
		}
		
		//control boton >
		if (num_layers <= 1) {
			this.disabled_btn('tab_left');
		}
		else if ((num_layers-1) == position) {
			this.disabled_btn('tab_left');
		}
		else if (num_layers >= 2) {
			this.enabled_btn('tab_left');
		}		
		//Control boton <
		if (num_layers <= 1) {
			this.disabled_btn('tab_right');
		}	
	}
	
	
	this.show_layer = function(path) {
		var tab = $('tab_'+path);
		//Si la pestana existe
		if (tab) {
			//Actualizamos los indices
			id_ant = id_act;
			id_act = path;
		
			//Activamos
			if (num_layers > 0) {
				tab.style.backgroundColor = "#DEDEDE";
				//Activamos el editor
				//editAreaLoader.switchToFile('editor_content', path, false);
				editAreaLoader.switchToFile('editor_content', path);
			}
			//Desactivamos, si el anterior y el actual son distintos
			if (id_ant != path) {
				var tab_ant = $('tab_'+id_ant);
				if (tab_ant) {
					//Desactivamos las pestanas
					tab_ant.style.backgroundColor = "#EEEEEE";
				}
			}
		}
	}
	
	
	this.rename_layer = function(path, newpath) {
		//Nos quedamos con el nombre del fichero
		var file_name = newpath.substring(newpath.lastIndexOf("/")+1, newpath.length);

		//Cambiamos los datos de la pestana
		var tab = $('tab_'+path);
		tab.name = newpath;
		tab.id = 'tab_'+newpath;
		
		var tab_img_loading = $('tab_img_loading_'+path);
		tab_img_loading.id = 'tab_img_loading_'+newpath;		
		
		var tab_name = $('tab_name_'+path);
		tab_name.innerHTML = file_name;
		tab_name.id = 'tab_name_'+newpath;

		var tab_status = $('tab_status_'+path);
		tab_status.id = 'tab_status_'+newpath;

		var tab_img_close = $('tab_img_close_'+path);
		tab_img_close.id = 'tab_img_close_'+newpath;
		
		//Cambiamos el id_act si es el caso
		if (id_act == path) {
			id_act = newpath;
		}
	}
	

	this.disabled_btn = function(id_btn) {
		var btn = $(id_btn);
		btn.src = "../../images/editor/tabs/"+id_btn+"_disabled.png";
		btn.disabled = true;
	}
	
	this.enabled_btn = function(id_btn) {
		var btn = $(id_btn);
		btn.src = "../../images/editor/tabs/"+id_btn+".png";
		btn.disabled = false;
	}

	//Mover <
	this.move_tab_right = function() {
		var btn = $('tab_right');
		if (btn.disabled == false) {
			if (position > 0) {
				position--;
				var tabs = $('tabs').childNodes;
				var tab = tabs[position];
				tab.style.display = 'block';
			}
		
			//Control del boton <
			if (position <= 0) {
				//document.getElementById('btn_right').disabled = true;
				this.disabled_btn('tab_right');
			}
			else {
				//document.getElementById('btn_right').disabled = false;
				this.enabled_btn('tab_right');
			}		
			//Control del boton >
			if (num_layers >= 2) {
				//document.getElementById('btn_left').disabled = false;
				this.enabled_btn('tab_left');
			}
			else {
				//document.getElementById('btn_left').disabled = true;
				this.disabled_btn('tab_right');
			}
		}
	}
	
	//Mover >
	this.move_tab_left = function() {
		var btn = $('tab_left');
		if (btn.disabled == false) {
			var tabs = $('tabs').childNodes;
			var tab = tabs[position];
			tab.style.display = 'none';
			position++;
			
			//Control del boton <			
			this.enabled_btn('tab_right');
			
			//Control del boton >
			if ((num_layers-1) == position) {
				this.disabled_btn('tab_left');
			}
		}
	}

	
	this.is_open_layer = function(path) {
		var tab = $('tab_'+path);
		return tab? true : false;

	}
	
	/*
	this.get_tabs = function() {
		var tabs = document.getElementById('tabs').childNodes;
		return tabs;
	}
	
	this.get_tab = function(id) {
		var tab = document.getElementById('tab_'+id);
		return tab;
	}
	*/
	
	this.get_path_act = function() {
		return id_act;
	}
	
	this.get_num_layers = function() {
		return num_layers;
	}
	
	this.set_file_edited_mode = function(id, status) {
		if(status) {
			$('tab_status_'+id).style.display = 'block';
		}
		else {
			$('tab_status_'+id).style.display = 'none';
			editAreaLoader.setFileEditedMode('editor_content', id, false);
		}
	}
	
	this.is_edited_file = function(id) {
		return $('tab_status_'+id).style.display == 'block';
	}
	
	
	this.get_opened_files = function() {
		var tabs = document.getElementById('tabs');
		var opened_files = new Array();
		var id_file;
		for (var i=0; i<tabs.childNodes.length; i++) {
			id_file = tabs.childNodes[i].id.substr(4);
			opened_files[i] = id_file;
		}
		return opened_files;
	}
		
	this.get_edited_files = function() {
		var tabs = $('tabs');
		var edited_files = new Array();
		var id_file;
		for (var i=0; i<tabs.childNodes.length; i++) {
			//id_file = tabs.childNodes[i].id.substring(4,tabs.childNodes[i].id.length);
			id_file = tabs.childNodes[i].id.substr(4);
			if (this.is_edited_file(id_file)) {
				edited_files.push(id_file);
			}
		}
		return edited_files;
	}		
	
	this.set_file_loading_mode = function(id, status) {
		if(status) {
			$('tab_img_loading_'+id).style.display = 'block';
		}
		else {
			$('tab_img_loading_'+id).style.display = 'none';
		}
	}

	
	
	this.show_result = function(id) {
		//Obtenemos las pestanas
		var tabbar = $('result_tabs');
		var tab_nodes = tabbar.childNodes;
		
		//Ponemos todas las pestanas apagadas
		for (var i=0; i<tab_nodes.length; i++) {
			if (tab_nodes[i].nodeType==1) {
				tab_nodes[i].style.backgroundColor = "#EEEEEE";
			}
		}
		
		//Obtenemos los contenedores
		var container = $('result_container_main');
		var container_nodes = container.childNodes;
	
		//Ponemos todos los contenedores ocultos
		for (var i=0; i<container_nodes.length; i++) {
			if (container_nodes[i].nodeType==1) {
				container_nodes[i].style.display = "none";
			}
		}
		
		//Encendemos la pestana
		var tab = $('result_tab_'+id);
		tab.style.backgroundColor = "#DEDEDE";
		
		var content = $('result_container_'+id);
		content.style.display = "block";		
	}
	
}


var tabs_manager = new Tabs_Manager();

